﻿using Styx;
using Styx.Common;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace Illidari.Core.Utilities
{
    class Log
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CurrentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static uint CurrentFury => StyxWoW.Me.GetPowerInfo(WoWPowerType.Fury).Current;

        
        //public static string lastDebugMSG;
        public static string lastInformationMSG;

        #region [Method] - Combat Log
        public static string lastCombatMSG;
        public static void combatLog(string Message, params object[] args)
        {
            if (Message == lastCombatMSG)
                return;
            if (Main.IS.GeneralDebug)
            {
                if (CurrentTarget != null)
                {
                    Logging.Write(Colors.Fuchsia, "[Illidari]: {0}" + string.Format($" on {CurrentTarget.SafeName} @ {CurrentTarget.HealthPercent.ToString("F2")}% at {CurrentTarget.Distance.ToString("F2")} yds with {CurrentFury} Fury"), Message, args);
                }
                else
                {
                    Logging.Write(Colors.Fuchsia, "[Illidari]: {0}" + string.Format($" on [no target] with {CurrentFury} Fury"), Message, args);
                }
            }
            else
            {
                Logging.Write(Colors.Fuchsia, "[Illidari]: {0}", Message, args);
            }
            lastCombatMSG = Message;
        }
        #endregion

        #region
        public static void pullMobLog(string Message, params object[] args)
        {
            if (Message == lastInformationMSG || !Main.IS.GeneralDebug) { return; }

            Logging.Write(Colors.Teal, "[Illidari]: {0}", Message, args);
            lastInformationMSG = Message;
        }
        #endregion

        #region Information Log

        public static void infoLog(string Message, params object[] args)
        {
            if (Message == lastInformationMSG || !Main.IS.GeneralDebug) { return; }
            
            Logging.Write(Colors.WhiteSmoke, "[Illidari]: {0}", Message, args);
            lastInformationMSG = Message;
        }

        #endregion

        #region [Method] - Diagnostics Log
        public static void diagnosticsLog(string Message, params object[] args)
        {
            if (Message == null)
                return;
            Logging.WriteDiagnostic(Colors.Firebrick, "[Error] {0}", String.Format(Message, args));
        }
        #endregion
    }
}
