﻿using Styx;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Illidari;

#region [Method] - Class Redundancy
using HK = Illidari.Core.Managers.Hotkeys;
using S = Illidari.Core.Spell;
using SB = Illidari.Core.Helpers.Spell_Book;
using U = Illidari.Core.Unit;
using I = Illidari.Core.Item;
using T = Illidari.Core.Managers.TalentManager;
using L = Illidari.Core.Utilities.Log;
using C = Illidari.Core.Helpers.Common;
using M = Illidari.Main;

#endregion

namespace Illidari.Rotation
{
    class Havoc
    {
        private static bool useOpenRotation = false;
        private static int openingRotationSkillsUsed = 0;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CurrentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static uint CurrentFury => StyxWoW.Me.GetPowerInfo(WoWPowerType.Fury).Current;

        #region Precombat Buffing
        public static async Task<bool> PreCombatBuffing()
        {
            if (HK.manualOn || Me.Combat || !Me.IsAlive || (Me.OnTaxi))
                return true;
            // check to see if we should use a flask
            if (await I.UseItem(I.FindBestPrecombatFlask(), !Me.HasAura(SB.FlaskList)))
            {
                return true;
            }
            return false;
        }
        #endregion

        #region Combat Buffing
        public static async Task<bool> CombatBuffing()
        {
            if (HK.manualOn || !Me.IsAlive || (!Me.GotTarget || !CurrentTarget.IsAlive) || (Me.OnTaxi))
                return true;
            if (!Me.IsAutoAttacking && CurrentTarget.IsValidCombatUnit()) { Lua.DoString("StartAttack()"); return true; }
            //
            // use potion - Change "true" to configurable
            return await I.UseItem(I.GetItemByName("Draenic Strength Potion"), true);
        }

        #endregion

        #region Pull Logic
        public static async Task<bool> Pull()
        {
           

            if (CurrentTarget.IsValidCombatUnit())
            {
                if (M.IS.GeneralFacing)
                {
                    // check to see if we need to face target
                    await C.FaceTarget(CurrentTarget);
                }

                if (!CurrentTarget.IsInMeleeRange(Me) && M.IS.GeneralMovement)
                {
                    L.infoLog("Tried to pull");
                    await CommonCoroutines.MoveTo(new WoWPoint(CurrentTarget.Location.X - 3, CurrentTarget.Location.Y - 3, CurrentTarget.Location.Z));
                }

                // throw a glaive first
                if (await S.Cast(SB.ThrowGlaive, CurrentTarget.Distance <= 30)) { return true; }

                // use to engage
                return await S.GCD(SB.FelRush, CurrentTarget.Distance <= 20);
            }

            //if (CurrentTarget != null)
            //{
            //    L.infoLog(string.Format($"CurrentTarget:{CurrentTarget.SafeName}.{CurrentTarget.Guid.Lowest}, IsValidCombatUnit: {CurrentTarget.IsValidCombatUnit()}"));
            //}
            //if (U.activeEnemies(Me.Location, 50).Count() > 0 && M.IS.GeneralTargeting)
            //{
            //    if (CurrentTarget != null)
            //    {
            //        L.infoLog(string.Format($"Current Target:{CurrentTarget.SafeName}.{CurrentTarget.Guid.GetFriendlyString()}, IsDead:{CurrentTarget.IsDead}"));
            //    }
            //    L.infoLog("Need a new target");
            //    var newUnits = U.activeEnemies(Me.Location, 30f).OrderBy(u => u.Distance);
            //    L.infoLog("Number of new units: " + newUnits.Count());
            //    var newUnit = newUnits.FirstOrDefault();
            //    L.infoLog("New unit targeted: " + newUnit.SafeName);
            //    if (newUnit != null)
            //    {

            //        L.infoLog(string.Format($"No target; trying to get new one @ {newUnit.SafeName}.{newUnit.Guid.Lowest}"));

            //        newUnit.Target();
            //    }
            //    return true;
            //}

            return true;
        }
        #endregion

        #region Combat Rotation

        #region Rotation Selector
        public static async Task<bool> RotationSelector()
        {
            // we are playing manual, i am not alive, or I am mounted or on taxi, do not continue
            if (HK.manualOn || !Me.IsAlive || (Me.OnTaxi))
                return true;
            // if I 
            

            if (M.IS.GeneralFacing)
            {
                // check to see if we need to face target
                await C.FaceTarget(CurrentTarget);
            }

            if (M.IS.GeneralMovement)
            {
                // ensure we are in melee range and not too close
                await C.EnsureMeleeRange(CurrentTarget);
            }

            // see if we need any defensive cooldowns
            if (await SaveMe()) { return true; }

            if ((HK.AoEOn || U.activeEnemies(Me.Location, 8f).Count() >= 3))
            {
                // try to use aoe abilities
                if (await AoE()) { return true; }
                // we were supposed to aoe, but nothing to use for aoe (or jumped back out of melee), so use single target
                if (await AoEDashing()) { return true; }
            }

            if (await OpeningRotationSingleTarget())
            {
                return true;
            }

            // default to single target if nothing else
            return await SingleTarget();
        }
        #endregion

        #region Save Me
        public static async Task<bool> SaveMe()
        {

            // use defensive cooldowns

            if (await I.UseItem(I.FindBestBandage(), Me.CurrentHealth < 70)) { return true; }


            if (await S.GCD(SB.Blur, Me.HealthPercent < 65)) { return true; }
            if (await S.GCD(SB.Darkness, Me.HealthPercent < 50)) { return true; }
            if (await S.GCD(SB.ChaosNova, Me.HealthPercent < 40)) { return true; }

            return false;
        }
        #endregion

        #region Area of Effect
        public static async Task<bool> AoE()
        {
            if (await S.GCD(SB.EyeBeam, true, "AoE")) { return true; }
            if (await S.Cast(SB.ChaosStrike, T.HavocChaosCleave, "AoE")) { return true; }
            if (await S.GCD(SB.BladeDance, true, "AoE")) { return true; }
            if (await S.Cast(SB.ChaosStrike, CurrentFury >= 70, "AoE")) { return true; }
            if (await S.Cast(SB.DemonsBite, true, "AoE")) { return true; }
            if (await S.Cast(SB.ThrowGlaive, !CurrentTarget.IsWithinMeleeRange, "AoE")) { return true; }

            return false;

        }
        public static async Task<bool> AoEDashing()
        {
            #region Multi-Target Vengeful Retreat
            // use it if we have Prepared talent differently
            if (await S.GCD(SB.VengefulRetreat, !S.OnCooldown(SB.FelRush)    // we can cast fel rush
                && CurrentFury <= 85                                        // and Fury <= 85
                && T.HavocPrepared                                          // We took prepared so use 85 or less
                && (S.CooldownTimeLeft(SB.FelRush) < 500), "AoED"))                 // and cooldown timer < 500ms (2nd one)
            { return true; }

            // use it different if we DO NOT have Prepared talent
            if (await S.GCD(SB.VengefulRetreat, !S.OnCooldown(SB.FelRush)       // we can cast fel rush
               && CurrentFury <= 70                                             // and Fury <= 70
               && !T.HavocPrepared                                              // We took prepared so use 85 or less
               && (S.CooldownTimeLeft(SB.FelRush) < 500), "AoED"))                      // and cooldown timer < 500ms (2nd one)
            { return true; }
            #endregion

            #region Multi-Target Fel Rush
            // use this in combination with vengeful retreat
            if (await S.GCD(SB.FelRush, T.HavocFelMastery       // we took the talent for fel mastery
                && CurrentFury <= 70                            // make sure we have 70 or less Fury
                && CurrentTarget.Distance >= 10                 // make sure we aren't too close
                && CurrentTarget.Distance <= 30, "AoED"))               // make sure we aren't too far
            { return true; }

            // use to engage
            if (await S.GCD(SB.FelRush, !T.HavocFelMastery      // we took the talent for fel mastery
                && CurrentTarget.Distance >= 10                 // make sure we aren't too close
                && CurrentTarget.Distance <= 30, "AoED"))               // make sure we aren't too far
            { return true; }
            #endregion

            return false;
        }
        #endregion

        #region Single Target

        /// <summary>
        /// this is the opening rotation for single target. Once activated, it will continue to use these abilities until it has been fulfilled and then reset again.
        /// </summary>
        /// <returns></returns>
        public static async Task<bool> OpeningRotationSingleTarget()
        {

            if (S.MaxChargesAvailable(SB.FelRush)           // make sure we have max charges saved up.
                && !CurrentTarget.IsInMeleeRange(Me)         // make sure we are not in melee range.
                && !S.OnCooldown(SB.MetamorphosisSpell))
            {
                useOpenRotation = true;
            }
            if (useOpenRotation)
            {
                L.infoLog("Ready for Havoc Single Target Opener: " + openingRotationSkillsUsed);
                if (openingRotationSkillsUsed == 0)
                {
                    // we haven't used an ability yet for opener, let's fel rush
                    if (await S.GCD(SB.FelRush, true, "Opener 1"))
                    {
                        openingRotationSkillsUsed++;
                    }
                }
                if (openingRotationSkillsUsed == 1)
                {
                    if (T.HavocFelMastery)
                    {
                        await S.GCD(SB.FelRush, true, "Opener 2");
                    }
                    openingRotationSkillsUsed++;
                }
                if (openingRotationSkillsUsed == 2)
                {
                    if (await S.CastGround(SB.MetamorphosisSpell, true, "Opener 3"))
                    {
                        // if we did metamorphosis then that's our last ability we can now continue single target
                        useOpenRotation = false;
                        openingRotationSkillsUsed = 0;
                    }
                }
                return true;
            }
            return false;
        }
        public static async Task<bool> SingleTarget()
        {

            if (await S.CastGround(SB.MetamorphosisSpell, true))
            { return true; }
            #region Single-Target Vengeful Retreat

            // chaos strike Fury dump
            if (await S.Cast(SB.ChaosStrike, CurrentFury >= 70
                && CurrentTarget.IsInMeleeRange(Me), "ST"))
            { return true; }

            // use it if we have Prepared talent differently
            if (await S.GCD(SB.VengefulRetreat, CurrentFury <= 85
                && !S.OnCooldown(SB.FelRush)
                && S.CooldownTimeLeft(SB.FelRush) < 500
                && T.HavocPrepared
                && CurrentTarget.IsInMeleeRange(Me), "ST1"))
            { return true; }

            // use it if we DO NOT have Prepared talent without Fury check
            if (await S.GCD(SB.VengefulRetreat, !S.OnCooldown(SB.FelRush)
                && S.CooldownTimeLeft(SB.FelRush) < 500
                && !T.HavocPrepared
                && CurrentTarget.IsInMeleeRange(Me), "ST2"))
            { return true; }

            #endregion

            #region Single-Target Fel Rush
            // use this in combination with vengeful retreat
            if (await S.Cast(SB.FelRush, T.HavocFelMastery
                && Me.CurrentTarget.Distance >= 10
                && Me.CurrentTarget.Distance <= 30,
                "ST 1"))
            { return true; }

            // use to engage
            if (await S.Cast(SB.FelRush, !CurrentTarget.IsInMeleeRange(Me)
                 && CurrentTarget.Distance >= 10
                 && CurrentTarget.Distance <= 30,
                 "ST 2"))
            { return true; }
            #endregion

            // only cast bite if we don't have DemonBlades.  DB removes the ability of Demon's bite
            if (await S.Cast(SB.DemonsBite, !T.HavocDemonBlades
                && CurrentTarget.IsInMeleeRange(Me), "ST"))
            { return true; }

            // melee range with Demon Blades
            if (await S.Cast(SB.ThrowGlaive, T.HavocDemonBlades
                && CurrentTarget.IsInMeleeRange(Me)
                && CurrentFury < 70, "ST"))
            { return true; }

            // nothing else to do so let's throw a glaive
            if (await S.Cast(SB.ThrowGlaive, T.HavocDemonBlades
                && !CurrentTarget.IsInMeleeRange(Me)
                && CurrentFury < 70, "ST"))
            { return true; }

            return false;

        }
        #endregion

        #endregion

    }
}
